<template>
    <div>
        <breadcrumb-component title="Centro de custos" :pages="breadPages"/>

        <panel-component title="Listar centro de custos" :pages="breadPages" length="6">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'centro-custos.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar centro de custo
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Cadastrado em</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="centroCusto in centroCustos">
                        <td>{{centroCusto.name}}</td>
                        <td>{{centroCusto.created_at | dateFormat}}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'centro-custos.edit', params: {id: centroCusto.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(centroCusto)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'centro-custos', name: 'Financeiro', active: false},
                    {link: 'centro-custos', name: 'Centro de custos', active: false},
                    {link: 'centro-custos', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadCentroCustos()
        },

        computed: {
            centroCustos() {
                return this.$store.state.centroCustos.items
            }
        },

        methods: {
            loadCentroCustos() {
                this.$store.dispatch('loadCentroCustos')
            },

            confirmDestroy(centroCusto) {
                this.$snotify.confirm(`Deseja realmente apagar o centro de custo: ${centroCusto.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyCentroCusto(centroCusto.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyCentroCusto(id) {
                this.$store.dispatch('destroyCentroCusto', id)
                    .then(() => {
                        this.loadCentroCustos()
                        this.$snotify.success('Centro de custo apagada com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar!', 'Error')
                    })
            }
        }
    }
</script>